
// Initialize global variables
var balls = new Array();			// Tracks dynamic ball objects
var numBalls = 0;					// The number of ball objects
var activeInd = false;				// Have the balls started moving?
var pauseInd = false;				// Are the balls paused?


// Adds a new ball object
function addBall() {
	// Create new ball object
	balls[numBalls] = new Object();
	balls[numBalls].id = 'ball' + numBalls;		// Name new ball object
	balls[numBalls].hStep = rand(10) + 1;		// Set horizontal step from 1-10
	balls[numBalls].vStep = rand(10) + 1;		// Set vertical step from 1-10
	balls[numBalls].bgColor = getRandomColor();	// Set background color

	// Add ball to bounding box
	var currContent = document.getElementById("BoundingBox").innerHTML;
	var newContent = '<DIV CLASS="ball" ID="ball' + numBalls + '" STYLE="background-color: ' + balls[numBalls].bgColor + '; z-index: ' + numBalls + ';">&nbsp;</DIV>';
	document.getElementById("BoundingBox").innerHTML = currContent + newContent;

	// Add row to Tracker
	if ( document.all ) {
		// If IE, do it the hard way
		newRow = document.all.TrackerGrid.insertRow();
		newCell = newRow.insertCell();
		newCell.innerHTML = balls[numBalls].id;
		newCell = newRow.insertCell();
		newCell.style.backgroundColor = balls[numBalls].bgColor;
		newCell.innerHTML = '&nbsp;';
		newCell = newRow.insertCell();
		newCell.id = balls[numBalls].id + 'Pos';
		newCell.innerHTML = '(0,0)';
	} else {
		// If not IE, do it the easy way
		document.getElementById("TrackerGrid").innerHTML += '<TR><TD>' + balls[numBalls].id + '</TD><TD STYLE="background-color: ' + balls[numBalls].bgColor + ';">&nbsp;</TD><TD ID="' + balls[numBalls].id + 'Pos">(0,0)</TD></TR>';
	}

	// Make ball move
	if ( !activeInd ) {
		activeInd = true;
		window.setInterval("moveBalls()", 50);
	}

	// Increment number of balls
	numBalls = numBalls + 1;

	// Change the ball count indicator
	document.getElementById("ballCount").innerHTML = numBalls + ' Bouncing Balls';
}


// Pause or resume ball movement
function pause() {
	// Switch the pause indicator
	pauseInd = !pauseInd;

	// Change the status indicator
	document.getElementById("ballStatus").innerHTML = pauseInd ? 'Paused' : 'Active';

	// Change the pause button's label text
	document.getElementById("btnPause").value = pauseInd ? 'Resume' : 'Pause';
}


// Cycle through balls and make them move one step
function moveBalls() {
	// If not paused
	if ( !pauseInd ) {
		// Cycle through the balls
		for ( i = 0; i < numBalls; i++ ) {
			// move each ball a single step
			moveBall(balls[i].id, i);
		}
	}
}


// Move the specified ball a single step
function moveBall(objID, idx) {
	// Get current position
	if (document.getElementById(objID).style.left == '') {
		x = 11;
		y = 11;
	} else {
		x = parseInt(document.getElementById(objID).style.left);
		y = parseInt(document.getElementById(objID).style.top);
	}

	// Adjust horizontal step
	if (( x + balls[idx].hStep < 11 ) || ( x + balls[idx].hStep > 461 )) {
		balls[idx].hStep = balls[idx].hStep * -1;
	}

	// Adjust vertical step
	if (( y + balls[idx].vStep < 11 ) || ( y + balls[idx].vStep > 461 )) {
		balls[idx].vStep = balls[idx].vStep * -1;
	}

	// Move pContent div
	document.getElementById(objID).style.left = (x + balls[idx].hStep) + "px";
	document.getElementById(objID).style.top = (y + balls[idx].vStep) + "px";

	// Update tracker
	document.getElementById(balls[idx].id + 'Pos').innerHTML = '(' + (x + balls[idx].hStep) + ',' + (y + balls[idx].vStep) + ')';
}

rnd.today=new Date();
rnd.seed=rnd.today.getTime();

function rnd() {
	rnd.seed = (rnd.seed*9301+49297) % 233280;
	return rnd.seed/(233280.0);
};

function rand(number) {
	return Math.ceil(rnd()*number);
};

function getRandomColor() {
	var r = hex(rand(255));
	var g = hex(rand(255));
	var b = hex(rand(255));

	r = r.length != 1 ? r : '0' + r;
	g = g.length != 1 ? g : '0' + g;
	b = b.length != 1 ? b : '0' + b;

	return '#' + r + g + b;
}

function hex(i) {
	var hexa = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 'A', 'B', 'C', 'D', 'E', 'F'];

	if (i < 0)
		return "00";
	else if (i > 255)
		return "FF";
	else
	return "" + hexa[Math.floor(i/16)] + hexa[i%16];
}

